#!/bin/bash

# start and enable mariadb
sudo systemctl enable --now mariadb

# mysql -u root -p
# password is blank, press Enter

# first setup the database, removing test user and test database
sudo mysql_secure_installation

# then setup the guacamole tables
# Test: sudo mysql -u root -p (enter password)

# create guacamole_db Database
#sudo mysql -u root -p
#mysql> CREATE DATABASE guacamole_db;
#mysql> quit

# create database guacamole_db
cat /usr/share/guacamole/auth-jdbc/mysql/schema/000-create-guacamole_db.sql | sudo mysql -u root -p
# create database tables
cat /usr/share/guacamole/auth-jdbc/mysql/schema/001-create-schema.sql | sudo mysql -u root -p guacamole_db
# create admin user guacadmin for administration of the guacamole users
cat /usr/share/guacamole/auth-jdbc/mysql/schema/002-create-admin-user.sql | sudo mysql -u root -p guacamole_db
# create database user
cat /usr/share/guacamole/auth-jdbc/mysql/schema/003-create-guacamole_user.sql | sudo mysql -u root -p

# default admin user:
# admin user: guacadmin
# admin passwort: guacadmin

# now create a user "guacamole_user" in the database who stores everything,
# see guacamole.properties for setting this username and password so guacamole frontend
# can access the database:

#sudo mysql -u root -p
# in mysql, enter:
#mysql> CREATE USER 'guacamole_user'@'localhost' IDENTIFIED BY 'some_password';
#mysql> GRANT SELECT,INSERT,UPDATE,DELETE ON guacamole_db.* TO 'guacamole_user'@'localhost';
#mysql> FLUSH PRIVILEGES;
#mysql> quit


